<template>
  <div class="page-users">
    <el-table v-loading="loading" :data="result ? result.users : []">
      <el-table-column fixed width="65">
        <template slot-scope="scope">
          <Avatar :user="scope.row" :size="40" />
        </template>
      </el-table-column>
      <el-table-column label="Name" prop="username">
        <template slot-scope="scope">
          <div style="white-space: nowrap">
            {{ scope.row.username }}
          </div>
        </template>
      </el-table-column>
      <el-table-column label="Display Name" prop="display_name" />
      <el-table-column label="Phone" prop="phone" />
      <el-table-column label="Email" prop="account.email" />
      <el-table-column label="Location">
        <template slot-scope="scope" v-if="scope.row.location !== null">
          {{ scope.row.location.city }}
          <template
            v-if="scope.row.location.city && scope.row.location.country"
          >
            <br />
          </template>
          {{ scope.row.location.country }}
        </template>
      </el-table-column>
      <el-table-column label="Data" prop="created_at">
        <template slot-scope="scope">
          <div style="white-space: nowrap">
            {{ format(new Date(scope.row.created_at), 'dd.MM.yyyy') }}
          </div>
        </template>
      </el-table-column>
      <el-table-column fixed="right" width="150">
        <template slot-scope="scope">
          <div style="display: flex; align-items: center">
            <div
              @click="changeActiveUser(scope.row)"
              style="margin-right: 25px"
            >
              <el-switch
                :active-value="false"
                :inactive-value="true"
                v-model="scope.row.blocked_for_search"
              ></el-switch>
            </div>
            <nuxt-link :to="`/users/${scope.row.username}`" target="_blank">
              <el-button>View</el-button>
            </nuxt-link>
          </div>
        </template>
      </el-table-column>
    </el-table>
    <div
      style="margin-top: 25px"
      v-if="
        result && result.users_aggregate && result.users_aggregate.aggregate
      "
    >
      <el-pagination
        @current-change="setPage"
        :current-page="page"
        :page-size="pageSize"
        layout="prev, pager, next"
        :total="result.users_aggregate.aggregate.count"
      >
      </el-pagination>
    </div>
  </div>
</template>

<script lang="ts">
import {
  defineComponent,
  useContext,
  computed,
  ref
} from '@nuxtjs/composition-api'
import { CurrentUserFragment } from '~/sdk/types'
import { useGetUsersQuery, useAdminEditUserMutation } from '~/sdk/hooks'
import Avatar from '@/components/ui/Avatar.vue'
import { format } from 'date-fns'
export default defineComponent({
  layout: 'admin',
  name: 'AdminUsersPage',
  components: { Avatar },
  setup(_, { root }) {
    const { route } = useContext()

    const pageSize = 15
    let page = ref(1 as number)
    const { result, loading } = useGetUsersQuery(
      computed(() => ({
        offset: pageSize * page.value - pageSize,
        limit: pageSize
      }))
    )
    const setPage = (val: any) => {
      page.value = val
    }

    const { mutate } = useAdminEditUserMutation({
      errorPolicy: 'all',
      context: {
        headers: {
          'x-hasura-role': 'administrator'
        }
      }
    })

    function changeActiveUser(user: CurrentUserFragment) {
      mutate({ id: user.id, blocked: user.blocked_for_search })
    }

    return {
      result,
      loading,
      changeActiveUser,
      format,
      page,
      pageSize,
      setPage
    }
  }
})
</script>

<style lang="scss" scoped>
.page-users {
  ::v-deep {
    .el-table .cell {
      white-space: nowrap !important;
    }
  }
}
</style>
